''' <summary>
''' Classe de gestion d'un programme
''' </summary>
''' <remarks></remarks>
Friend NotInheritable Class ClsProgram
    Implements IRunnable

    ''' <summary>
    ''' Nom du programme
    ''' </summary>
    ''' <remarks></remarks>
    Private mName As String
    ''' <summary>
    ''' Catgorie du programme
    ''' </summary>
    ''' <remarks></remarks>
    Private mCategory As String
    ''' <summary>
    ''' Code pour l'execution du programme
    ''' </summary>
    ''' <remarks></remarks>
    Private mRun As String
    ''' <summary>
    ''' Raccourcis
    ''' </summary>
    ''' <remarks></remarks>
    Private mShortcut As String

    ''' <summary>
    ''' Constructeur
    ''' </summary>
    ''' <param name="pName">Nom</param>
    ''' <param name="pCategory">Catgorie</param>
    ''' <param name="pRun">Code</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal pName As String, ByVal pCategory As String, ByVal pShort As String, ByVal pRun As String)
        mName = pName
        mCategory = pCategory
        mShortcut = pShort.ToUpper
        mRun = pRun
    End Sub

    ''' <summary>
    ''' Retourne la catgorie du programme
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Category() As String Implements IRunnable.Category
        Get
            Return mCategory
        End Get
    End Property
    ''' <summary>
    ''' retourne le nom du programme
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Name() As String Implements IRunnable.Name
        Get
            Return mName
        End Get
    End Property
    ''' <summary>
    ''' retourne le code
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function Run() As String Implements IRunnable.Run
        Return mRun
    End Function
    ''' <summary>
    ''' Retourne le raccourci du programme
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ShortCut() As String Implements IRunnable.ShortCut
        Get
            Return mShortcut
        End Get
    End Property
End Class
