Imports System.xml


Module MdlFriend

    ''' <summary>
    ''' Enumration des sons
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum ESound
        ''' <summary>
        ''' Aucun son
        ''' </summary>
        ''' <remarks></remarks>
        Aucun = 0
        ''' <summary>
        ''' Erreur
        ''' </summary>
        ''' <remarks></remarks>
        Erreur = 1
        ''' <summary>
        ''' Programme lanc
        ''' </summary>
        ''' <remarks></remarks>
        RunPrg = 2
        ''' <summary>
        ''' Avertissement
        ''' </summary>
        ''' <remarks></remarks>
        Avert = 3
    End Enum

    ''' <summary>
    ''' Sons activs ?
    ''' </summary>
    ''' <remarks></remarks>
    Private mBeepEnabled As Boolean = True

    Private mInit As Boolean = False

    ''' <summary>
    ''' Joue un son
    ''' </summary>
    ''' <param name="pSound"></param>
    ''' <remarks></remarks>
    Public Sub Beep(ByVal pSound As ESound)
        If Not BeepEnabled Then Exit Sub
        Try
            Select Case pSound
                Case ESound.Avert
                    Console.Beep(1000, 50)
                Case ESound.Erreur
                    Console.Beep(1200, 75)
                    Console.Beep(1000, 50)
                    Console.Beep(800, 75)
                Case ESound.RunPrg
                    Console.Beep(800, 75)
                    Console.Beep(1000, 50)
                    Console.Beep(1200, 75)
            End Select
        Catch ex As Exception
        End Try
    End Sub
    ''' <summary>
    ''' Rcupre les valeurs des options stockes dans le fichier de configuration
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub InitParams()
        If mInit Then Exit Sub

        For Each lNode As XmlNode In mDocument.DocumentElement
            If lNode.Name = "option" Then
                Select Case GetAttribute(lNode, "name").ToLower
                    Case "beepenabled"
                        'BeepEnabled
                        mBeepEnabled = (GetAttribute(lNode, "value", "1") = "1")
                End Select
            End If
        Next

        mInit = True
    End Sub
    ''' <summary>
    ''' Met  jour la valeur d'une otpion
    ''' </summary>
    ''' <param name="pOptName">Nom de l'option</param>
    ''' <param name="pValue">Valeur</param>
    ''' <remarks></remarks>
    Private Sub UpdateOptionValue(ByVal pOptName As String, ByVal pValue As String)
        For Each lNode As XmlNode In mDocument.DocumentElement
            If lNode.Name = "option" Then
                If GetAttribute(lNode, "name") = pOptName Then
                    Dim lAttribut As XmlAttribute = mDocument.CreateAttribute("value")
                    lAttribut.InnerText = pValue
                    lNode.Attributes.SetNamedItem(lAttribut)
                    Try
                        mDocument.Save(My.Resources.FileName)
                    Catch ex As Exception

                    End Try

                    Exit Sub
                End If
            End If
        Next

        Dim lNde As XmlElement = mDocument.CreateElement("option")
        Dim lAttr As XmlAttribute = mDocument.CreateAttribute("name")
        lAttr.InnerText = pOptName
        lNde.Attributes.Append(lAttr)
        lAttr = mDocument.CreateAttribute("value")
        lAttr.InnerText = pValue
        lNde.Attributes.Append(lAttr)

        mDocument.DocumentElement.AppendChild(lNde)

        Try
            mDocument.Save(My.Resources.FileName)
        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' Retourne ou dfinit si les sons sont actifs
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property BeepEnabled() As Boolean
        Get
            InitParams()
            Return mBeepEnabled
        End Get
        Set(ByVal value As Boolean)
            InitParams()
            If value = mBeepEnabled Then Exit Property
            mBeepEnabled = value
            UpdateOptionValue("BeepEnabled", IIF(mBeepEnabled, "1", "0"))
        End Set
    End Property


    ''' <summary>
    ''' Retourne une des 2 expressionss
    ''' </summary>
    ''' <typeparam name="T">Type  utiliser</typeparam>
    ''' <param name="pCondition">Condition</param>
    ''' <param name="pTrue">Valeur retourne si <c>pCondition</c> est <c>True</c></param>
    ''' <param name="pFalse">Valeur retourne si <c>pCondition</c> est <c>False</c></param>
    ''' <returns></returns>
    ''' <remarks>Permet d'viter l'utilisation de <c>CType</c> avec <c>IIF</c> par dfaut</remarks>
    Public Function IIF(Of T)(ByVal pCondition As Boolean, ByVal pTrue As T, ByVal pFalse As T) As T
        If pCondition Then
            Return pTrue
        Else
            Return pFalse
        End If
    End Function
End Module
