Imports System.xml


Module MdlMain

    ''' <summary>
    ''' Document XML pour la liste
    ''' </summary>
    ''' <remarks></remarks>
    Public mDocument As New XmlDocument
    ''' <summary>
    ''' Liste des programmes
    ''' </summary>
    ''' <remarks></remarks>
    Private mProgramLst As New Dictionary(Of String, IRunnable)
    ''' <summary>
    ''' Liste des programmes et des scripts classs par catgories
    ''' </summary>
    ''' <remarks></remarks>
    Private mCategories As New SortedList(Of String, SortedList(Of String, IRunnable))
    ''' <summary>
    ''' Liste des codes - programmes
    ''' </summary>
    ''' <remarks></remarks>
    Private mCodes As New Dictionary(Of String, IRunnable)
    ''' <summary>
    ''' Programe ou script slectionn
    ''' </summary>
    ''' <remarks></remarks>
    Private mSelected As IRunnable = Nothing
    ''' <summary>
    ''' Code  insrer  chaque execution
    ''' </summary>
    ''' <remarks></remarks>
    Private mRoot As String = ""


    Sub Main(ByVal pArgs As String())
        Try

            If pArgs.Length > 0 Then
                My.Computer.FileSystem.WriteAllText("ReadMe.txt", My.Resources.Help, False)
                Console.WriteLine("{0}", My.Resources.Help)
#If DEBUG Then
            console.ReadKey 
#End If
                Exit Sub
            End If

            CreateProgramList()
            ShowList(False)

            Dim lKey As ConsoleKeyInfo

            Dim lStr As String = ""
            If mSelected IsNot Nothing Then
                Dim lValues As New List(Of IRunnable)
                Dim lKeys As New List(Of String)

                lValues.AddRange(mCodes.Values)
                lKeys.AddRange(mCodes.Keys)

                lStr = lKeys(lValues.IndexOf(mSelected))
            End If

            Do
                ShowList(False)
                Console.Write("Code du programme  lancer : {0}   ", lStr)
                Console.CursorLeft -= 3

                If Console.WindowHeight < Console.CursorTop + 1 Then
                    Try
                        Console.WindowHeight = Console.CursorTop + 1
                    Catch ex As Exception
                        Console.WindowHeight = Console.LargestWindowHeight
                    End Try
                    Console.WindowTop = 0
                End If

                lKey = Console.ReadKey()

                If lKey.Key = ConsoleKey.Escape Then
                    Exit Do
                ElseIf lKey.Key = ConsoleKey.Delete Then
                    lStr = ""
                    mSelected = Nothing
                ElseIf lKey.Key = ConsoleKey.Backspace Then
                    If lStr.Length > 1 Then
                        lStr = lStr.Substring(0, lStr.Length - 1)
                    ElseIf lStr.Length > 0 Then
                        lStr = ""
                    Else
                        Beep(ESound.Avert)
                    End If
                ElseIf lKey.Key = ConsoleKey.Enter Then
                    Dim lPrg As IRunnable = Nothing
                    If mCodes.TryGetValue(lStr, lPrg) Then
                        Run(lPrg)
                        Beep(ESound.RunPrg)
                    ElseIf mSelected IsNot Nothing Then
                        Run(mSelected)
                        Beep(ESound.RunPrg)
                    Else
                        Beep(ESound.Erreur)
                    End If
                ElseIf lKey.Key = ConsoleKey.DownArrow Then
                    Dim lValues As New List(Of IRunnable)
                    Dim lKeys As New List(Of String)

                    lValues.AddRange(mCodes.Values)
                    lKeys.AddRange(mCodes.Keys)

                    If mSelected Is Nothing Then
                        mSelected = lValues(0)
                        lStr = lKeys(0)
                    ElseIf lValues.LastIndexOf(mSelected) < lValues.Count - 1 Then
                        mSelected = lValues(lValues.LastIndexOf(mSelected) + 1)
                        lStr = lKeys(lValues.IndexOf(mSelected))
                    Else
                        Beep(ESound.Avert)
                    End If
                ElseIf lKey.Key = ConsoleKey.UpArrow Then
                    Dim lValues As New List(Of IRunnable)
                    Dim lKeys As New List(Of String)

                    lValues.AddRange(mCodes.Values)
                    lKeys.AddRange(mCodes.Keys)

                    If mSelected Is Nothing Then
                        mSelected = lValues(lValues.Count - 1)
                        lStr = lKeys(lValues.IndexOf(mSelected))
                    ElseIf lValues.IndexOf(mSelected) > 0 Then
                        mSelected = lValues(lValues.IndexOf(mSelected) - 1)
                        lStr = lKeys(lValues.IndexOf(mSelected))
                    Else
                        Beep(ESound.Avert)
                    End If
                ElseIf lKey.Key = ConsoleKey.F1 Then
                    MdlFriend.BeepEnabled = Not MdlFriend.BeepEnabled
                ElseIf lKey.Key = ConsoleKey.F5 Then
                    Console.Clear()
                    Console.WindowHeight = 10

                    CreateProgramList()
                    ShowList(False)
                    If mSelected IsNot Nothing Then
                        Dim lValues As New List(Of IRunnable)
                        Dim lKeys As New List(Of String)

                        lValues.AddRange(mCodes.Values)
                        lKeys.AddRange(mCodes.Keys)

                        lStr = lKeys(lValues.IndexOf(mSelected))
                    End If
                ElseIf Char.IsLetter(lKey.KeyChar) Or Char.IsNumber(lKey.KeyChar) Then
                    Dim lTmp As String = (lStr + lKey.KeyChar).ToUpper
                    Dim lKeys As New List(Of String)
                    Dim lSel As IRunnable = Nothing

                    lKeys.AddRange(mCodes.Keys)

                    For Each lKey1 As String In lKeys
                        If lKey1 = lTmp Or (lKey1 Like (lTmp + "*")) Then
                            lSel = mCodes(lKey1)
                            Exit For
                        End If
                    Next

                    If lSel IsNot Nothing Then
                        mSelected = lSel
                        lStr = lTmp
                    End If
                Else
                    Beep(ESound.Avert)
                End If
            Loop
        Catch ex As Exception
            Console.WriteLine("Une exception non gre est survenue :")
            Console.WriteLine("{0}", ex)
            Console.WriteLine("")
            Console.WriteLine("")
            Console.WriteLine("Si le problme persiste sans raison, contactez-moi :")
            Console.WriteLine(" - nhprog@laposte.net")
            Console.WriteLine(" - http://nhen0039.chez-alice.fr/")
            Console.WriteLine("")
            Console.WriteLine("Appuyez sur une touche pour quitter le programme.")

            If Console.CursorTop > Console.WindowHeight Then
                Console.WindowTop = 0
                If Console.CursorTop > Console.LargestWindowHeight Then
                    Console.WindowHeight = Console.LargestWindowHeight
                Else
                    Console.WindowHeight = Console.CursorTop()
                End If
            End If

            Console.ReadKey()
        Finally
#If DEBUG Then
        Console.ReadKey()
#End If
        End Try
    End Sub

    ''' <summary>
    ''' Cr la liste des programmes
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub CreateProgramList()
        Dim lPrg As IRunnable = Nothing
        Dim lScript As ClsScript = Nothing
        Dim lLst As SortedList(Of String, IRunnable) = Nothing

        'Nettoyage de la liste
        mProgramLst.Clear()
        mCategories.Clear()
        mCodes.Clear()
        mSelected = Nothing

        'ouverture du fichier
        If IO.File.Exists(My.Resources.FileName) Then
            mDocument.Load(My.Resources.FileName)
        Else
            mDocument.LoadXml(My.Resources.NewFile)
            Try
                mDocument.Save(My.Resources.FileName)
            Catch ex As Exception

            End Try
        End If

        'programmes
        For Each lNode As XmlNode In mDocument.DocumentElement
            If lNode.Name.ToLower = "program" Then
                lPrg = New ClsProgram(GetAttribute(lNode, "name"), GetAttribute(lNode, "category"), GetAttribute(lNode, "shortcut"), lNode.InnerText)
                mProgramLst.Item(lPrg.Name) = lPrg
                If Not mCategories.TryGetValue(lPrg.Category, lLst) Then
                    mCategories.Item(lPrg.Category) = New SortedList(Of String, IRunnable)
                    lLst = mCategories.Item(lPrg.Category)
                End If
                lLst.Item(lPrg.Name) = lPrg
            End If
        Next

        'Scripts
        For Each lNode As XmlNode In mDocument.DocumentElement
            If lNode.Name.ToLower = "script" Then
                lScript = New ClsScript(GetAttribute(lNode, "name"), GetAttribute(lNode, "category"), GetAttribute(lNode, "shortcut"))
                For Each lNode1 As XmlNode In lNode
                    If lNode1.Name.ToLower = "program" Then
                        If mProgramLst.TryGetValue(GetAttribute(lNode1, "name"), lPrg) Then
                            lScript.Add(lPrg)
                        End If
                    End If
                Next

                If Not mCategories.TryGetValue(lScript.Category, lLst) Then
                    mCategories.Item(lScript.Category) = New SortedList(Of String, IRunnable)
                    lLst = mCategories.Item(lScript.Category)
                End If
                lLst.Item(lScript.Name) = lScript

                mProgramLst.Item(lScript.Name) = lScript
            End If
        Next

        'Action par dfaut
        For Each lNode As XmlNode In mDocument.DocumentElement
            If lNode.Name.ToLower = "default" Then
                Dim lDef As String = GetAttribute(lNode, "name")
                For Each lLst1 As SortedList(Of String, IRunnable) In mCategories.Values
                    For Each lLst2 As IRunnable In lLst1.Values
                        If lDef = lLst2.Name Then
                            mSelected = lLst2
                            Exit For
                        End If
                    Next
                    If mSelected IsNot Nothing Then Exit For
                Next
            ElseIf lNode.Name.ToLower = "root" Then
                mRoot = lNode.InnerText
            End If
        Next
    End Sub
    ''' <summary>
    ''' Affiche la liste des programmes
    ''' </summary>
    ''' <param name="pReplaceCursor">Prcise si le curseur est replac  sa position d'origine  al fin de l'execution</param>
    ''' <remarks></remarks>
    Private Sub ShowList(Optional ByVal pReplaceCursor As Boolean = True)
        Dim lLastPosition As New Point(Console.CursorLeft, Console.CursorTop)

        Console.CursorLeft = 0
        Console.CursorTop = 0

        Dim lMaxLen As Integer = 0

        For Each lRun As IRunnable In mProgramLst.Values
            lMaxLen = Math.Max(lRun.Name.Length, lMaxLen)
        Next

        mCodes.Clear()

        Dim lCatNum As Integer = Asc("A")
        Dim lRunNum As Integer = 0

        For Each lLst As KeyValuePair(Of String, SortedList(Of String, IRunnable)) In mCategories

            Console.ForegroundColor = ConsoleColor.Green
            Console.BackgroundColor = ConsoleColor.Black
            Console.WriteLine("{0}    {1}", Chr(lCatNum), lLst.Key)

            lRunNum = 1

            For Each lLst1 As IRunnable In lLst.Value.Values

                If lLst1 Is mSelected Then
                    Console.ForegroundColor = ConsoleColor.White
                    Console.BackgroundColor = ConsoleColor.Black
                Else
                    Console.ForegroundColor = ConsoleColor.DarkYellow
                    Console.BackgroundColor = ConsoleColor.Black
                End If

                Console.WriteLine(" {0}{1,-2} {2,-" + CStr(lMaxLen + 2) + "} {3}", New Object() {Chr(lCatNum), lRunNum, lLst1.Name, IIF(lLst1.ShortCut.Length > 0, "(" + lLst1.ShortCut + ")", "")})

                mCodes.Add(Chr(lCatNum) + CStr(lRunNum), lLst1)
                If lLst1.ShortCut.Length > 0 Then
                    Try
                        mCodes.Add(lLst1.ShortCut, lLst1)
                    Catch ex As Exception
                    End Try
                End If

                lRunNum += 1
            Next

            lCatNum += 1
        Next

        Console.ForegroundColor = ConsoleColor.Magenta
        Console.BackgroundColor = ConsoleColor.Black

        Dim lStr As String = "-"
        Do While lStr.Length < Console.WindowWidth
            lStr += "-"
        Loop
        Console.Write(lStr)

        lStr = "| "
        lStr += "F1:Sound(" + IIF(MdlFriend.BeepEnabled, "ON", "OFF") + ") - F5:Rafraichir liste"
        Do While lStr.Length < Console.WindowWidth - 1
            lStr += " "
        Loop
        lStr += "|"
        Console.Write(lStr)

        lStr = "|"
        Do While lStr.Length < Console.WindowWidth - 1
            lStr += "-"
        Loop
        lStr += "|"
        Console.Write(lStr)

        'Info programme

        lStr = "Programme AUTORUN V1.0 cr par Nicolas HENRY, http://nhen0039.chez-alice.fr/"
        Do While lStr.Length < Console.WindowWidth - 3
            lStr = " " + lStr + " "
        Loop

        Do While lStr.Length < Console.WindowWidth - 2
            lStr += " "
        Loop

        lStr = "|" + lStr + "|"
        Console.Write(lStr)

        lStr = "-"
        Do While lStr.Length < Console.WindowWidth
            lStr += "-"
        Loop
        Console.Write(lStr)

        Console.ForegroundColor = ConsoleColor.Gray
        Console.BackgroundColor = ConsoleColor.Black

        If pReplaceCursor Then
            Console.CursorLeft = lLastPosition.X
            Console.CursorTop = lLastPosition.Y
        End If
    End Sub
    ''' <summary>
    ''' Lance un programme ou un script
    ''' </summary>
    ''' <param name="pPrg">Programme  lancer</param>
    ''' <remarks></remarks>
    Private Sub Run(ByVal pPrg As IRunnable)
        Dim lFileName As String = IO.Path.Combine(My.Computer.FileSystem.SpecialDirectories.Temp, "Autorun.bat")

        Dim lCode As String = ""

        lCode = My.Application.Info.DirectoryPath.Substring(0, 2) + vbCrLf
        lCode += "cd " + My.Application.Info.DirectoryPath + vbCrLf
        lCode += mRoot + vbCrLf
        lCode += pPrg.Run

        My.Computer.FileSystem.WriteAllText(lFileName, lCode, False)

        Diagnostics.Process.Start(lFileName).WaitForExit()

        'IO.File.Delete(lFileName)
    End Sub

    ''' <summary>
    ''' Retourne le texte d'un arrtibut
    ''' </summary>
    ''' <param name="pNode">Noeud XML</param>
    ''' <param name="pName">Nom de l'attribut</param>
    ''' <param name="pDefault">Valeur par dfaut</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetAttribute(ByVal pNode As XmlNode, ByVal pName As String, Optional ByVal pDefault As String = "") As String
        pNode = pNode.Attributes.GetNamedItem(pName)
        If pNode Is Nothing Then
            Return pDefault
        Else
            Return pNode.InnerText
        End If
    End Function
End Module
